#!python
# -*- coding: utf-8 -*-
__version__ = "$Revision: 1.1 $"
# $Source: /home/mechanoid/projects/py/sklearn/04-regr/RCS/main.py,v $
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
#
#       OS : GNU/Linux 4.7.6-1-ARCH 
# COMPILER : Python 3.5.2
#
#   AUTHOR : Evgeny S. Borisov
# 
#    http://www.mechanoid.kiev.ua
#  e-mail : nn@mechanoid.kiev.ua
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

import numpy as np
import matplotlib.pyplot as plt

# генеруем набор данных (случайные точки) 
n_observations = 100
xs = np.linspace(-3, 3, n_observations).reshape(n_observations,1)
ys = np.sin(xs) + np.random.uniform(-0.5, 0.5, n_observations).reshape(n_observations,1)

# рисуем набор данных
plt.scatter(xs, ys, label="data")
plt.grid(True)
axes = plt.gca()
axes.set_xlim([-3.1,3.1])
axes.set_ylim([-1.6,1.6])

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

from sklearn.linear_model import LinearRegression
from sklearn.preprocessing import PolynomialFeatures

regr = LinearRegression() # регрессия

# преобразование данных для полиномиальной регрессии
d=9 # степень полиномиальной регрессии
xc =  PolynomialFeatures(degree=d).fit_transform(xs)

regr = regr.fit(xs, ys) # строим линейную регрессию
yr = regr.predict(xs) # результат на тестовом наборе
plt.plot(xs, yr, label='linear (d=1)', color='green', lw=2, linestyle='-')

regr = regr.fit(xc, ys) # строим полиномиальную регрессию
yr = regr.predict(xc) # результат на тестовом наборе
plt.plot(xs, yr, label='polynomial (d=%i)'%d, color='red', lw=2, linestyle='-')

# рисуем результаты
plt.legend(loc='upper left')
plt.savefig('result/plot1.png', dpi=60)
